
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <stdarg.h>

#include "globals.h"

FILE *stdlist  = NULL;
char *listfile = NULL;

int verbose;

main(
	int    argc,
	char **argv)
{
	int c;
	int dumpcode = 0;

	extern int optind, opterr;
	extern char *optarg;

	opterr = 0;

	while ((c = getopt(argc, argv, "vd")) != -1) {
		switch (c) {
		default:
	baduse:
			fprintf(stderr, "\
Usage: %s [-v][-d] file\n",
				__pname);
			exit(2);
		case 'v':
			verbose = 9;
			break;
		case 'd':
			dumpcode = 1;
			break;
		}
	}
	if (optind >= argc)
		goto baduse;

	codeinit();

	for ( ; optind < argc; ++optind) {
		if (freopen(argv[optind], "r", stdin) == NULL)
			pexit(argv[optind]);
		codeparse();
	}
	codefini();

	exit(0);
}

static char *
str2dup(
	char *a,
	char *b)
{
	char *s = malloc(strlen(a) + strlen(b) + 1);

	strcpy(s, a);
	strcat(s, b);
	return (s);
}

void
pexit(char *fmt, ...)
{
	va_list ap;

	va_start(ap, fmt);
	fprintf(stderr, "%s: ", __pname);
	vfprintf(stderr, fmt, ap);
	fprintf(stderr, "\n");
	va_end(ap);

	exit(1);
}

void *
nullck(p)
	void *p;
{
	if (!p) {
		fprintf(stderr, "%s: Out of memory\n", __pname);
		exit(1);
	}
	return (p);
}
