
#include <stdio.h>

main(argc, argv)
	char **argv;
{
	int c, c1, c2;
	int n;
	int addr = 0;
	int word2;
	int bas = 0;
	char *mnem;

	while (*++argv && **argv == '-') {
		fprintf(stderr, "\
Usage: dis6303 [file]\n");
		exit(2);
	}
	if (*argv && freopen(*argv, "r", stdin) == NULL) {
		perror(*argv);
		exit(1);
	}
	if (argv[1] && sscanf(argv[1], "%i", &bas) == 1)
		;
	if (argv[1] && argv[2] && sscanf(argv[2], "%i", &addr) == 1)
		for (c = 0; c < addr; ++c)
			getchar();

	while ((c = getchar()) != EOF) {
		n = printf("L%04X: ", bas+addr++);

#define byte (addr+=1, (c1=getchar()))
#define word (addr+=2, ((c1=getchar())<<8)|(c2=getchar()))

#define gb1 (addr+=1, (c1=getchar()));
#define gb2 (addr+=1, (c2=getchar()));

#define gw gb1 gb2 word2 = ((c1<<8)|c2);

#define s n += printf
#define b n += printf
#define w n += printf

		c1 = c2 = -1;

		switch (c) {
		case 0x01: s("nop");
			break;
		case 0x04: s("lsr d");
			break;
		case 0x05: s("asl d");
			break;
		case 0x06: s("tap");
			break;
		case 0x07: s("tpa");
			break;
		case 0x08: s("inc x");
			break;
		case 0x09: s("dec x");
			break;
		case 0x0A: s("clr v");
			break;
		case 0x0B: s("set v");
			break;
		case 0x0C: s("clr c");
			break;
		case 0x0D: s("set c");
			break;
		case 0x0E: s("cli");
			break;
		case 0x0F: s("sei");
			break;
		case 0x10: s("sub a, b");
			break;
		case 0x11: s("cmp a, b");
			break;
		case 0x16: s("ld b, a");
			break;
		case 0x17: s("ld a, b");
			break;
		case 0x18: s("xch d, x");
			break;
		case 0x19: s("da a");
			break;
		case 0x1A: s("slp");
			break;
		case 0x1B: s("add a, b");
			break;

		case 0x20: gb1 b("bra L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x21: gb1 b("brn L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x22: gb1 b("bhi L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x23: gb1 b("bls L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x24: gb1 b("bcc L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x25: gb1 b("bcs L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x26: gb1 b("bne L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x27: gb1 b("beq L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x28: gb1 b("bvc L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x29: gb1 b("bvs L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x2A: gb1 b("bpl L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x2B: gb1 b("bmi L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x2C: gb1 b("bge L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x2D: gb1 b("blt L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x2E: gb1 b("bgt L%04X", bas+addr+(int)(char)c1);
			break;
		case 0x2F: gb1 b("ble L%04X", bas+addr+(int)(char)c1);
			break;

		case 0x30: s("tsx");
			break;
		case 0x31: s("inc sp");
			break;
		case 0x32: s("pop a");
			break;
		case 0x33: s("pop b");
			break;
		case 0x34: s("dec sp");
			break;
		case 0x35: s("txs");
			break;
		case 0x36: s("push a");
			break;
		case 0x37: s("push b");
			break;
		case 0x38: s("pop x");
			break;
		case 0x39: s("rts");
			break;
		case 0x3A: s("add x, b");
			break;
		case 0x3B: s("rti");
			break;
		case 0x3C: s("push x");
			break;
		case 0x3D: s("mul");
			break;
		case 0x3E: s("wai");
			break;
		case 0x3F: s("swi");
			break;

		case 0x40: s("neg a");
			break;
		case 0x50: s("neg b");
			break;
		case 0x60: b("neg X[%d]", byte);
			break;
		case 0x70: gw  w("neg *%04X", word2);
			break;

		case 0x61: gb1 gb2 b("aim X[%d], $%02X", c2, c1);
			break;
		case 0x71: gb1 gb2 b("aim @%02X, $%02X", c2, c1);
			break;

		case 0x62: gb1 gb2 b("oim X[%d], $%02X", c2, c1);
			break;
		case 0x72: gb1 gb2 b("oim @%02X, $%02X", c2, c1);
			break;

		case 0x43: s("cpl a");
			break;
		case 0x53: s("cpl b");
			break;
		case 0x63: b("com X[%d]", byte);
			break;
		case 0x73: gw w("com *%04X", word2);
			break;

		case 0x44: s("lsr a");
			break;
		case 0x54: s("lsr b");
			break;
		case 0x64: b("lsr X[%d]", byte);
			break;
		case 0x74: gw w("lsr *%04X", word2);
			break;

		case 0x65: gb1 gb2 b("eim X[%d], $%02X", c2, c1);
			break;
		case 0x75: gb1 gb2 b("eim @%02X, $%02X", c2, c1);
			break;

		case 0x46: s("rrc a");
			break;
		case 0x56: s("rrc b");
			break;
		case 0x66: b("rrc X[%d]", byte);
			break;
		case 0x76: w("rrc *%04X", word);
			break;

		case 0x47: s("asr a");
			break;
		case 0x57: s("asr b");
			break;
		case 0x67: b("asr X[%d]", byte);
			break;
		case 0x77: w("asr *%04X", word);
			break;

		case 0x48: s("asl a");
			break;
		case 0x58: s("asl b");
			break;
		case 0x68: b("asl X[%d]", byte);
			break;
		case 0x78: w("asl *%04X", word);
			break;

		case 0x49: s("rlc a");
			break;
		case 0x59: s("rlc b");
			break;
		case 0x69: b("rlc X[%d]", byte);
			break;
		case 0x79: w("rlc *%04X", word);
			break;

		case 0x4A: s("dec a");
			break;
		case 0x5A: s("dec b");
			break;
		case 0x6A: b("dec X[%d]", byte);
			break;
		case 0x7A: w("dec *%04X", word);
			break;

		case 0x6B: gb1 gb2 b("tst X[%d], $%02X", c2, c1);
			break;
		case 0x7B: gb1 gb2 b("tst @%02X, $%02X", c2, c1);
			break;

		case 0x4C: s("inc a");
			break;
		case 0x5C: s("inc b");
			break;
		case 0x6C: b("inc X[%d]", byte);
			break;
		case 0x7C: w("inc *%04X", word);
			break;

		case 0x4D: s("tst a");
			break;
		case 0x5D: s("tst b");
			break;
		case 0x6D: b("tst X[%d]", byte);
			break;
		case 0x7D: w("tst *%04X", word);
			break;

		case 0x6E: b("jmp X[%d]", byte);
			break;
		case 0x7E: w("jmp L%04X", word);
			break;

		case 0x4F: s("clr a");
			break;
		case 0x5F: s("clr b");
			break;
		case 0x6F: b("clr X[%d]", byte);
			break;
		case 0x7F: w("clr *%04X", word);
			break;

		case 0x8D: gb1 w("bsr L%04X", bas+addr+(int)(char)c1);
			break;

		case 0x9D: gb1 w("jsr @%02X", c1);
			break;
		case 0xAD: gb1 w("jsr X[%d]", c1);
			break;
		case 0xBD: gw  w("jsr L%04X", word2);
			break;

		case 0x8C: gw  b("cmp x, $%04X", word2); break;
		case 0x9C: gb1 b("cmp x, @%02X", c1); break;
		case 0xAC: gb1 b("cmp x, X[%d]", c1); break;
		case 0xBC: gw  b("cmp x, *%04X", word2); break;

		case 0xCC: gw  b("ld d, $%04X", word2); break;
		case 0xDC: gb1 b("ld d, @%02X", c1); break;
		case 0xEC: gb1 b("ld d, X[%d]", c1); break;
		case 0xFC: gw  b("ld d, *%04X", word2); break;

		case 0x8E: gw  b("ld sp, $%04X", word2); break;
		case 0x9E: gb1 b("ld sp, @%02X", c1); break;
		case 0xAE: gb1 b("ld sp, X[%d]", c1); break;
		case 0xBE: gw  b("ld sp, *%04X", word2); break;

		case 0xCE: gw  b("ld x, $%04X", word2); break;
		case 0xDE: gb1 b("ld x, @%02X", c1); break;
		case 0xEE: gb1 b("ld x, X[%d]", c1); break;
		case 0xFE: gw  b("ld x, *%04X", word2); break;

		case 0x9F: gb1 b("st sp, @%02X", c1); break;
		case 0xAF: gb1 b("st sp, X[%d]", c1); break;
		case 0xBF: gw  b("st sp, *%04X", word2); break;

		case 0xDD: gb1 b("st d, @%02X", c1); break;
		case 0xED: gb1 b("st d, X[%d]", c1); break;
		case 0xFD: gw  b("st d, *%04X", word2); break;

		case 0xDF: gb1 b("st x, @%02X", c1); break;
		case 0xEF: gb1 b("st x, X[%d]", c1); break;
		case 0xFF: gw  b("st x, *%04X", word2); break;

		default:
			if ((c & 0x80) == 0) {
				s("???");
				break;
			}
			mnem = 0;
			switch (c & 0x0F) {
			case 0x00: mnem="sub"; break;
			case 0x01: mnem="cmp"; break;
			case 0x02: mnem="sbc"; break;
			case 0x04: mnem="and"; break;
			case 0x05: mnem="bit"; break;
			case 0x06: mnem="ld"; break;
			case 0x07: mnem="st"; break;
			case 0x08: mnem="xor"; break;
			case 0x09: mnem="adc"; break;
			case 0x0A: mnem="or"; break;
			case 0x0B: mnem="add"; break;
			}
			if (mnem) {
				switch (c & 0xF0) {
				case 0x80: gb1 b("%s a, $%02X", mnem,c1); break;
				case 0x90: gb1 b("%s a, @%02X", mnem,c1); break;
				case 0xA0: gb1 b("%s a, X[%d]", mnem,c1); break;
				case 0xB0: gw  b("%s a, *%04X", mnem,word2); break;
				case 0xC0: gb1 b("%s b, $%02X", mnem,c1); break;
				case 0xD0: gb1 b("%s b, @%02X", mnem,c1); break;
				case 0xE0: gb1 b("%s b, X[%d]", mnem,c1); break;
				case 0xF0: gw  b("%s b, *%04X", mnem,word2); break;
				default:
					mnem=0;
				}
			} else {
				switch (c & 0x4F) {
				case 0x03: mnem="sub d,";break;
				case 0x43: mnem="add d,";break;
				case 0x0C: mnem="cmp x,";break;
				case 0x4C: mnem="ld d,";break;
				}
				if (mnem) {
					switch (c & 0x30) {
					case 0x00: gw  b("%s $%04X", mnem,word2); break;
					case 0x10: gb1 b("%s @%02X", mnem,c1);break;
					case 0x20: gb1 b("%s X[%d]", mnem,c1); break;
					case 0x30: gw  b("%s *%04X", mnem,word2); break;
					default:
						mnem=0;
					}
				}
			}
			if (mnem)
				break;

		case 0x87:
		case 0xC7:
		case 0xCD:
		case 0x8F:
		case 0xCF:
			s("???");
			break;
		}
		do {
			putchar(' ');
		} while (++n < 20);

		printf("# %02X", c);
		if (c1 != -1)
			printf(" %02X", c1);
		if (c2 != -1)
			printf(" %02X", c2);

		printf(" \n");
	}
	exit(1);
}

