
#include <sys/types.h>
#include <sys/time.h>
#include <termios.h>
#include <signal.h>

main(int argc, char **argv)
{
	char *ttyname ="/dev/ttyw1";
	char *cmd = argv[1];
	int ttyfd, msk;
	char oc, c;
	struct timeval tv;
	struct termios t;

	if ((ttyfd = open("/dev/ttyw1", 2)) == -1) {
		perror(ttyname);
		exit(1);
	}

	tcgetattr(ttyfd, &t);
	cfmakeraw(&t);
	cfsetspeed(&t, 1200);

	t.c_lflag &= ~(ICANON|ECHO|ECHOE|ECHONL|NOKERNINFO|ISIG|ECHOCTL);
	t.c_iflag &= ~(ISTRIP|IXON|IXOFF|BRKINT|INPCK|INLCR|ICRNL|IMAXBEL);
	t.c_oflag &= ~(OPOST);
	t.c_cflag &= ~(CSIZE|PARODD|CSTOPB);
	t.c_cflag |=  (CS8|PARENB|CLOCAL);

	tcsetattr(ttyfd, TCSANOW, &t);

	if (cmd) {
		write(ttyfd, "\0", 1);
		write(ttyfd, cmd, strlen(cmd));
		write(ttyfd, "\4", 1);
	}
	if (argc > 2) {
		int fd, cc;
		char buf[8192];

		if ((fd = open(argv[2], 0)) != -1) {
			tv.tv_sec  = 2;
			tv.tv_usec = 0;
			select(0, 0, 0, 0, &tv);

			while ((cc = read(fd, buf, sizeof(buf))) > 0)
				write(ttyfd, buf, cc);
		}
		exit(0);
	}

	tv.tv_sec  = 0;
	tv.tv_usec = 750000;
	select(0, 0, 0, 0, &tv);

	tcflush(ttyfd, TCIFLUSH);
	write(ttyfd, "\0\5", 2);

	oc = '\n';
	for (;;) {
		msk = 1 << ttyfd;
		tv.tv_sec  = 0;
		tv.tv_usec = 500000;
		if (select(ttyfd + 1, &msk, 0, 0, &tv) <= 0)
			break;
		if (read(ttyfd, &c, 1) != 1)
			break;
		if (c != 0 && c != 4 && c != 5) {
			oc = c;
			write(1, &c, 1);
			if (c == '\n')
				break;
		}
	}
	if (oc != '\n')
		write(1, "\n", 1);

	exit(0);
}
